stages:
  - testing # Запуск тестів
  - history_copy # Копіювання результату тестів з попереднього запуску тестів
  - reports # Генерація звіту
  - deploy # Публікація звіту на gitlab pages

chrome_job:
  stage: testing
  services:
    - selenium/standalone-chrome
  image: python:3.9
  tags:
    - docker
    - ubuntu
  before_script:
    - python3 -m venv venv
    - source venv/bin/activate
    - pip install --upgrade pip
    - pip install -r requirements.txt
  script:
    - pytest --alluredir=./allure-results tests/
  allow_failure: true
  artifacts:
    when: always
    paths:
      - ./allure-results
    expire_in: 1 day
  only:
    - dev
    - master

history_job:
  stage: history_copy
  tags:
    - docker
    - ubuntu
  image: storytel/alpine-bash-curl
  script:
    - 'curl --location --output artifacts.zip "https://gitlab.com/api/v4/projects/30450494/jobs/artifacts/dev/download?job=pages&job_token=$CI_JOB_TOKEN"'
    - apk add unzip
    - unzip artifacts.zip
    - chmod -R 777 public
    - cp -r ./public ./allure-results
  allow_failure: true
  artifacts:
    paths:
      - ./allure-results
    expire_in: 1 day
  only:
    - dev
    - master

allure_job:
  stage: reports
  tags:
    - docker
    - ubuntu
  image: frankescobar/allure-docker-service
  script:
    - allure generate -c ./allure-results -o ./allure-report
  artifacts:
    paths:
      - ./allure-results
      - ./allure-report
    expire_in: 1 day
  only:
    - dev
    - master

pages:
  stage: deploy
  script:
    - mkdir public
    - mv ./allure-report/* public
  artifacts:
    paths:
      - public
  only:
    - dev
    - master
